#include <jni.h>
#include "GL4D/gl4droid.h"

GLuint _pId, _posHandle, _colorHandle;

void init(const char * vs, const char * fs) {
    glClearColor(0, 0, 0, 1);
    gl4duGenMatrix(GL_FLOAT, "modelViewMatrix");
    gl4duGenMatrix(GL_FLOAT, "projectionMatrix");
    if(!(_pId = gl4droidCreateProgram(vs, fs))) return;
    _posHandle = glGetAttribLocation(_pId, "vPosition");
    _colorHandle = glGetAttribLocation(_pId, "vColor");
    return;
}

void reshape(int w, int h) {
    glViewport(0, 0, w, h);
    gl4duBindMatrix("projectionMatrix");
    gl4duLoadIdentityf();
    gl4duFrustumf(-0.5, 0.5, -0.5 * h / w, 0.5 * h / w, 1.0, 1000.0);
    gl4duBindMatrix("modelViewMatrix");
}

void draw(void) {
    static GLfloat a0 = 0.0f;
    const GLfloat data[] = {
            // 4 vertices
            -1, -1, 1, -1, -1, 1, 1, 1,
            // 4 RGB colors
            1, 0, 0, 0, 1, 0, 0, 0, 1, 1, 1, 0
    };
    glClear( GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);
    glUseProgram(_pId);

    glVertexAttribPointer(_posHandle, 2, GL_FLOAT, GL_FALSE, 0, data);
    glEnableVertexAttribArray(_posHandle);
    glVertexAttribPointer(_colorHandle, 3, GL_FLOAT, GL_FALSE, 0, &data[8]);
    glEnableVertexAttribArray(_colorHandle);
    gl4duBindMatrix("modelViewMatrix");
    gl4duLoadIdentityf();
    gl4duTranslatef(0, 0, -6);
    gl4duRotatef(a0, 0, 1, 0);
    gl4duRotatef(2 * a0, 1, 0, 0);
    /* envoi de toutes les matrices stockees par GL4D */
    gl4duSendMatrices();
    glDrawArrays(GL_TRIANGLE_STRIP, 0, 4);
    a0 += 1.4f;
}


JNIEXPORT void JNICALL Java_fr_grafeet_simplegl4d_SimpleGL4DView_ninit(JNIEnv *env, jobject obj, jstring vs_, jstring fs_) {
    const char *vs = (*env)->GetStringUTFChars(env, vs_, 0);
    const char *fs = (*env)->GetStringUTFChars(env, fs_, 0);
    init(vs, fs);
    (*env)->ReleaseStringUTFChars(env, vs_, vs);
    (*env)->ReleaseStringUTFChars(env, fs_, fs);
}

JNIEXPORT void JNICALL Java_fr_grafeet_simplegl4d_SimpleGL4DView_nreshape(JNIEnv *env, jobject obj, jint width, jint height) {
    reshape(width, height);
}

JNIEXPORT void JNICALL Java_fr_grafeet_simplegl4d_SimpleGL4DView_ndraw(JNIEnv * env, jobject obj) {
    draw();
}

